window.addEventListener('load', function() {
  Blockly.defineBlocksWithJsonArray([
    {
      "type": "move",
      "message0": "→",
      "previousStatement": null,
      "nextStatement": null,
    },
    {
      "type": "clockwise",
      "message0": "⤾",
      "previousStatement": null,
      "nextStatement": null,
    },
    {
      "type": "anticlockwise",
      "message0": "⤿",
      "previousStatement": null,
      "nextStatement": null,
    },
  ]);

  Blockly.JavaScript['move']          = (block) => { return "__move;" }
  Blockly.JavaScript['anticlockwise'] = (block) => { return "__anticlockwise;" }
  Blockly.JavaScript['clockwise']     = (block) => { return "__clockwise;" }

  const workspace    = Blockly.inject('blocklyDiv', {toolbox: document.getElementById('toolbox'), zoom: {startScale: 1.3}});
  const orientations = ['right', 'bottom', 'left', 'top']
  const base         = robozzle.outerHTML
  let timeout_id     = null


  async function __end_action() {
    if (document.querySelector('.robot.outside')) {
      alert('Perdu');

      return false
    }

    document.querySelector('.robot.star')?.classList?.remove('star')

    if (document.querySelector('.star') == undefined) {
      alert('Gagné !');

      return false
    }

    await new Promise((resolve) => setTimeout(resolve, 500))

    return true
  }

  function __move() {
    robot = robozzle.querySelector('.robot')

    if (robozzle.classList.contains('right')) {
      robot.nextElementSibling.classList.add("robot")
    } else if (robozzle.classList.contains('left')) {
      robot.previousElementSibling.classList.add("robot")
    } else if (robozzle.classList.contains('top')) {
      robot.parentNode.previousElementSibling.children[Array.prototype.indexOf.call(robot.parentNode.children, robot)].classList.add("robot")
    } else if (robozzle.classList.contains('bottom')) {
      robot.parentNode.nextElementSibling.children[Array.prototype.indexOf.call(robot.parentNode.children, robot)].classList.add("robot")
    }

    robot.classList.remove("robot")
  }

  function __anticlockwise() {
    let index = orientations.indexOf(robozzle.getAttribute('class'))

    index = (index == 0 ? orientations.length - 1 : index - 1)
    robozzle.setAttribute('class', orientations[index])
  }

  function __clockwise() {
    let index = orientations.indexOf(robozzle.getAttribute('class'))

    index = (index == orientations.length - 1 ? 0 : index + 1)
    robozzle.setAttribute('class', orientations[index])
  }

  async function execCode(id_max) {
    let code        = Blockly.JavaScript.workspaceToCode(workspace);

    robozzle.outerHTML = base;
    for (const step of code.split(';')) {
      if (step != "") {
        eval(`${step}()`)

        const res = await __end_action()

        if (res == false)
          return ;
      }
    }
  }

  document.querySelector('#exec').addEventListener('click', function() {
    Array.from(workspace.getAllBlocks(true), (a) => { a.setColour("#000000") })
    execCode("start")
  })
})
